#                                                         -*- Perl -*-
# Copyright (C) 2000  Satoru Takabayashi
# Copyright (C) 2000  Kazuhiko Shiozaki
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
use strict;
use FileHandle;

# temp.bmp $B$r(B temp.png $B$KJQ49$9$k%W%m%0%i%`!#(B
# $B4D6-$K$"$o$;$F=$@5$7$F$/$@$5$$!#(B
# $B;d$N4D6-$G$O(B 'convert temp.bmp temp.png' $B$@$H(B SEGV $B$K$J$j$^$7$?!#(B
my $convert_program = 'convert temp.bmp PNM:- | convert PNM:- temp.png';

my $source_directory = shift;

my $handle = FileHandle->new();
if (!$handle->open("$source_directory/DATA/main.txt", 'r')) {
  die "failed to open the file: $source_directory/DATA/main.txt\n";
}
# $B%S%C%HH?E>$7$?2~9T%3!<%I(B (\x100-\x0a) $B$G9T$KJ,$1$k!#(B
$/ = "\xf5";
binmode $handle;

my $handle_in = FileHandle->new();
if (!$handle_in->open("$source_directory/DATA/img.dat", 'r')) {
  die "failed to open the file: $source_directory/DATA/img.dat\n";
}
binmode $handle_in;

my %count = ();
my $new_offset = 0;
my $loop = 1;
while (1) {
  $_ = ~ $handle->getline;
  last if !$_;
  if (/^IMG=([0-9A-F]{8}),([0-9A-F]{8})$/) {
    my $offset_hex = $1;
    my $length_hex = $2;

    # $B=EJ#$7$?8+=P$78l$N=hM}(B
    next if (defined $count{$offset_hex});

    $count{$offset_hex}=1;
    print STDERR "$loop: $offset_hex $length_hex\n";
    $loop++;
    my $offset = hex $offset_hex;
    my $length = hex $length_hex;
    my $handle_out = FileHandle->new();
    if (!$handle_out->open("temp.bmp", 'w')) {
      die "failed to open the file: temp.bmp\n";
    }
    binmode $handle_out;
    seek($handle_in, $offset, 0) || die "Seek Error\n";
    read $handle_in, my $content, $length || die "Read Error\n";
    print $handle_out $content || die "Write Error\n";
    $handle_out->close();
    system $convert_program;
    system "cat temp.png >> img.dat";
    my $new_length = -s 'temp.png';
    printf("%s %s %08x %08x\n", $offset_hex, $length_hex,
	   $new_offset, $new_length);
    $new_offset += $new_length;
  }
}
